unit Guide;

interface

uses
  SysUtils;

type
  Guiding = class
  public
    procedure versionGuide(v: String; comments: Boolean);
  end;

const
  VERSION_TEXT = 'version.txt';

implementation

procedure Guiding.versionGuide(v: String; comments: Boolean);
begin
  WriteLn( 'Sjisutf16 FPC Version ' + v );
  WriteLn('');
  if comments then
    begin
      WriteLn('sjisutf16 SJIS            # Produce sjisutf16.txt ');
      WriteLn('sjisutf16 SJIS UTF16      # Produce a new file. ');
      WriteLn('sjisutf16 -o UTF16 SJIS   # Produce a new file. ');
      WriteLn('sjisutf16 -o UTF16 < SJIS # Every line includes 0Dh. ');
      WriteLn('sjisutf16 -0 SJIS         # Every line includes 0Dh. ');
      WriteLn('sjisutf16 -t SJIS UTF16   # SJIS has the same time as UTF16. ');
      WriteLn('sjisutf16 -a SJIS         # Acquire a table name from set_sjisutf16.txt ');
      WriteLn('sjisutf16 -b SJIS         # Produce binary.tmp ');
      WriteLn('sjisutf16 -b SJIS SJIS    # Produce and rename binary.tmp ');
      WriteLn('sjisutf16 -b -y SJIS      # Do not remove binary.tmp ');
      WriteLn('sjisutf16 -d SJIS         # Do not search a table. ');
      WriteLn('sjisutf16 -G              # Guide ');
      WriteLn('sjisutf16 -LF SJIS        # 0Dh is removed from every line. ');
      WriteLn('sjisutf16 -s SJIS         # Remove control characters. ');
      WriteLn('sjisutf16 -w SJIS         # -w shows which table sjisutf16 uses.');
      WriteLn('sjisutf16 -V              # Version ');
    end
  else
    begin
      WriteLn('sjisutf16 SJIS            ');
      WriteLn('sjisutf16 SJIS UTF16      ');
      WriteLn('sjisutf16 -o UTF16 SJIS   ');
      WriteLn('sjisutf16 -o UTF16 < SJIS ');
      WriteLn('sjisutf16 -0 SJIS         ');
      WriteLn('sjisutf16 -t SJIS UTF16   ');
      WriteLn('sjisutf16 -a SJIS         ');
      WriteLn('sjisutf16 -b SJIS         ');
      WriteLn('sjisutf16 -b SJIS SJIS    ');
      WriteLn('sjisutf16 -b -y SJIS      ');
      WriteLn('sjisutf16 -d SJIS         ');
      WriteLn('sjisutf16 -G              ');
      WriteLn('sjisutf16 -LF SJIS        ');
      WriteLn('sjisutf16 -s SJIS         ');
      WriteLn('sjisutf16 -w SJIS         ');
      WriteLn('sjisutf16 -V              ');
    end;

end;

end.
