unit FinalEffect;

interface

uses
  SysUtils;

type
  FinalEffects = class
  private
    carriage_return: Boolean;
    file_name: String;
    new_name: String;
    no_removing: Boolean;
    no_searching: Boolean;
    path_name: String;
    selected_directory_has_priority: Boolean;
    which_table: Boolean;
  public
    function carriageReturn: Boolean;
    function fileName: String;
    function newName: String;
    function noRemoving: Boolean;
    function noSearching: Boolean;
    function pathName: String;
    function priority: Boolean;
    function whichTable: Boolean;
    procedure setting; overload;
    procedure setting(fn: String; nn: String; pn: String;
      cr: Boolean; nr: Boolean; ns: Boolean; sd: Boolean; wt: Boolean); overload;

  end;

const
  FINAL_INTEGER = 2147483647; { 7FFFFFFFh }

implementation

function FinalEffects.carriageReturn: Boolean;
begin
  Result := carriage_return;
end;

function FinalEffects.fileName: String;
begin
  Result := file_name;
end;

function FinalEffects.newName: String;
begin
  Result := new_name;
end;

function FinalEffects.noRemoving: Boolean;
begin
  Result := no_removing;
end;

function FinalEffects.noSearching: Boolean;
begin
  Result := no_searching;
end;

function FinalEffects.pathName: String;
begin
  Result := path_name;
end;

function FinalEffects.priority: Boolean;
begin
  Result := selected_directory_has_priority;
end;

function FinalEffects.whichTable: Boolean;
begin
  Result := which_table;
end;

procedure FinalEffects.setting;
begin
{ String }
  file_name := '';
  new_name := '';
  path_name := '';

{ Boolean }
  carriage_return := False;
  no_removing := False;
  no_searching := False;
  selected_directory_has_priority := False;
  which_table := False;
end;

procedure FinalEffects.setting(fn: String; nn: String; pn: String; 
  cr: Boolean; nr: Boolean; ns: Boolean; sd: Boolean; wt: Boolean);

begin
{ String }
  file_name := fn;
  new_name := nn;
  path_name := pn;

{ Boolean }
  carriage_return := cr;
  no_removing := nr;
  no_searching := ns;
  selected_directory_has_priority := sd;
  which_table := wt;
end;

end.
