program Surro;
{$APPTYPE CONSOLE}

{*
Surro FPC Version 1.03
Producing a CSV file from surrogate-pair hexadecimals
Copyright 2020 Sogaya

Free Pascal Compiler 3.0.4

*}

uses
  SysUtils,
  AnsiQueue in 'AnsiQueue.pas',
  ConvertWide in 'ConvertWide.pas',
  DivideSJIS in 'DivideSJIS.pas',
  ErrorText in 'ErrorText.pas',
  FieldsArray in 'FieldsArray.pas',
  Guide in 'Guide.pas',
  MessagesText in 'MessagesText.pas',
  PathEXE in 'PathEXE.pas',
  SearchBinary in 'SearchBinary.pas',
  SparseUTF16 in 'SparseUTF16.pas',
  SurrogatePairs in 'SurrogatePairs.pas',
  SurroHtml in 'SurroHtml.pas',
  TimeName in 'TimeName.pas',
  Ucombo in 'Ucombo.pas';

{$R *.RES}

const
  C_ERR = 'err';
  CUT_HERE_HTML = 'cut_here.html';
  GUIDE_TERM = '-G';
  SURRO_CSV = 'surro.csv';
  SURRO_HTML = 'surro.html';
  SURRO_TEXT = 'surro.txt';
  TEXT_FILE = '.txt';
  VERSION_NUMBER = '1.03';
  VERSION_WITH_COMMENTS = True;
  VERSION_WITHOUT_COMMENTS = False;

var
  g: Guiding;
  htmlFile: textFile;
  L: TableHTML;
  p: SurrogatePairList;
  s: String;
  testFile: textFile;
  x: ErrorTexts;

begin
  s := ParamStr(1);
  if Length(s) > 0 then
    begin
      if CompareStr(s, GUIDE_TERM) = 0 then
        begin
          g := Guiding.Create;
          g.versionGuide(VERSION_NUMBER, VERSION_WITH_COMMENTS);
          g.Free;

          Halt(1);
        end
      else
        begin
          g := Guiding.Create;
          g.versionGuide(VERSION_NUMBER, VERSION_WITHOUT_COMMENTS);
          g.Free;

          Halt(1);
        end;

    end;

  try
    AssignFile(testFile, SURRO_TEXT);
    Reset(testFile);
    CloseFile(testFile);
  except
    s := 'Reset() error-114: ' + SURRO_TEXT;
    x := ErrorTexts.Create;
    x.setting(C_ERR, TEXT_FILE, s);
    x.Free;
    Halt(1);
  end;

  p := SurrogatePairList.Create;
  p.setting(SURRO_TEXT, SURRO_CSV);
  p.reading;
  p.Free;

  try
    AssignFile(htmlFile, CUT_HERE_HTML);
    Reset(htmlFile);
    CloseFile(htmlFile);

    L := TableHTML.Create;
    L.setting(SURRO_TEXT, SURRO_HTML);
    L.reading;
    L.Free;
  except
    Halt(0);
  end;

end.

