unit SurroHtml;

{$I+}

interface

uses
  Windows, SysUtils, ErrorText, FinalEffect, ConvertWide;

type AnsiCharArray = array[0..4095] of AnsiChar;

type
  TableHTML = class
  private
    a: AnsiCharArray;
    A_SIZE: Integer;
    A_SIZE_1: Integer;
    B_110110_S: Integer;
    B_110111_S: Integer;
    beginning: Integer;
    CLEAR_ARRAY: AnsiCharArray;
    combo: array of AnsiChar;
    combo_size: Integer;
    comboLength: Integer;
    COMMA_C: AnsiChar;
    count: Integer;
    CUT_HERE: array[0..17] of Integer;
    dough: array of AnsiChar;
    dough_size: Integer;
    dough_size_1: Integer;
    E: array[0..255] of Integer;
    file_name: String;
    H: array[0..7] of Integer;
    H_0A_C: AnsiChar;
    H_0D_C: AnsiChar;
    H_FE_C: AnsiChar;
    H_FF_C: AnsiChar;
    higher_part_of_kanji: Integer;
    lower_part_of_kanji: Integer;
    LOWER_PART_MASK: Integer;
    new_name: String;
    t: FinalEffects;
    TABLE_NUMBER: array[0..30] of String;
    TABLE_ROW: array[1..29] of String;
    trace: Integer;
    u: ConvertWiden;
    x: ErrorTexts;
    Y_COUNT: Integer;
    Y_COUNT_1: Integer;
    function bufferingWriting(comboLength: Integer): Integer;
    function copying_string_to_part_of_array(z: String; m: Integer): Integer;
    function E_table: Integer;
    function file_size(name: String): Integer;
    function head_of_HTML(m: Integer): Integer;
    function hexadecimalCharacter(c: Char): Boolean;
    function newLine(m: Integer): Integer;
    function setBufferSize: Integer;
    function tail_of_HTML(m: Integer): Integer;
  public
    destructor Destroy; override;
    function hexadecimal_sequence_to_integer(s: PChar; s_length: Integer): Integer;
    function reading: Integer;
    procedure setting(fn: String; nn: String);
  end;

const
  B_110110 = 54;
  B_110111 = 55;
  BEGINNING_OF_TABLE_ROW = '<tr><td><p class="item">';
  BOM_SIZE = 2;
  C_ERR = 'err';
  COMBO_ERROR = -3;
  COMMA_BYTE = 44; { 2Ch, ',' }
  CUT_HERE_HTML = 'cut_here.html';
  CUT_HERE_SIZE = 18; { 9 * SIZE_OF_WIDECHAR }
  CUT_HERE_SIZE_1 = 17; { CUT_HERE_SIZE - 1 }
  EMPTY = '';
  END_OF_HEADER = 26;
  END_OF_TABLE_ROW = '</p></td></tr>';
  EXPANSION_FACTOR = 256;
  FIELD_SEPARATOR = '</p></td><td><p class="item">';
  FILE_ERROR = -2;
  FINAL_INTEGER = 2147483647; { 7FFFFFFFh }
  GROUP_SIZE = 12;
  H_00010000 = 65536;
  H_00FF = 255;
  H_0A = 10; { LF }
  H_0D = 13; { CR }
  H_2D = 45; { '-' }
  H_30 = 48; { '0' }
  H_31 = 49; { '1' }
  H_39 = 57; { '9' }
  H_3E = 62; { '>' }
  H_3F = 63;
  H_41 = 65; { 'A' }
  H_42 = 66; { 'B' }
  H_43 = 67; { 'C' }
  H_46 = 70; { 'F' }
  H_D840 = 55360;
  H_DC02 = 56322;
  H_FE = 254;
  H_FF = 255;
  HEXADECIMAL_CHARACTERS = '0123456789ABCDEF';
  KANJI_SIZE = 2;
  LINE01 = '      <tr>';
  LINE02 = '        <td id="table1">';
  LINE03 = '          <table summary="list_of_surrogate_pairs">';
  LINE04 = '            <tr>';
  LINE05 = '              <td>';
  LINE06 = '                <p class="fixed"></p>';
  LINE07 = '              </td>';
  LINE08 = '              <td>';
  LINE09 = '                <p class="fixed">ʃTQ[g</p>';
  LINE10 = '              </td>';
  LINE11 = '              <td>';
  LINE12 = '                <p class="fixed">ʃTQ[g</p>';
  LINE13 = '              </td>';
  LINE14 = '              <td>';
  LINE15 = '                <p class="fixed">ʒu</p>';
  LINE16 = '              </td>';
  LINE17 = '              <td>';
  LINE18 = '                <p class="fixed">ʃItZbg</p>';
  LINE19 = '              </td>';
  LINE20 = '              <td>';
  LINE21 = '                <p class="fixed">ʃItZbg</p>';
  LINE22 = '              </td>';
  LINE23 = '              <td>';
  LINE24 = '                <p class="fixed">֕</p>';
  LINE25 = '              </td>';
  LINE26 = '            </tr>';
  LINE27 = '          </table>';
  LINE28 = '        </td>';
  LINE29 = '      </tr>';
  MAXIMUM_TABLE_NUMBER = 30;
  AWAY_FROM_CUT_HERE = 30;
  NEAR_END_OF_TABLE = 27;
  NOT_CONVERTED = -1;
  SIZE_OF_ANSICHAR = 1;
  SIZE_OF_WIDECHAR = 2;
  TABLE_ROW_ARRAY_COUNT = 29;
  TEXT_FILE = '.txt';

implementation

destructor TableHTML.Destroy;
begin
  combo := nil;
  t.Free;
  u.Free;

  inherited Destroy;
end;

function TableHTML.bufferingWriting(comboLength: Integer): Integer;
var
  block_has_been_written: Integer;
  exit_code: Integer;
  k: Integer;
  n: Integer;
  newFile: File;
  s: String;
begin
  exit_code := 0;
  n := 0;

{ Writing }
  try
    AssignFile(newFile, new_name);
    Rewrite(newFile, SIZE_OF_ANSICHAR);

    repeat
      a := CLEAR_ARRAY;

      for k := 0 to A_SIZE_1 do
      begin
        a[k] := combo[n];
        Inc(n);
        if n >= comboLength then
          begin
            A_SIZE := k + 1;
            break;
          end;

      end;

      BlockWrite(newFile, a, A_SIZE, block_has_been_written);
    until n >= comboLength;

    CloseFile(newFile);
    A_SIZE := SizeOf(a);
  except
    s := 'Rewrite() error-103: ' + new_name;
    x := ErrorTexts.Create;
    x.setting(C_ERR, TEXT_FILE, s);
    x.Free;
    exit_code := FILE_ERROR;
  end;

  Result := exit_code;
end;

function TableHTML.copying_string_to_part_of_array(z: String; m: Integer): Integer;
var
  c: WideChar;
  first_byte: Integer;
  i: Longint;
  k: Integer;
  n: Integer;
  second_byte: Integer;
begin
  u.produce_UTF16_phrase( PAnsiChar(z), Length(z) );
  Y_COUNT := u.UTF16_phrase_size;
  Y_COUNT_1 := Y_COUNT - 1;

  for k := 0 to Y_COUNT_1 do
  begin
    c := u.copyingArrayItem(k);
    i := Ord(c);

    if i > H_FF then
      begin
        first_byte := i and H_00FF;
        combo[m] := Chr(first_byte); { little-endian architecture }
        n := i shr 8;
        second_byte := n and H_00FF;
        combo[ m + 1 ] := Chr(second_byte);
        Inc(m, SIZE_OF_WIDECHAR);
      end
    else
      begin
{ ASCII }
        combo[m] := Chr(i);
        combo[ m + 1 ] := #0;
        Inc(m, SIZE_OF_WIDECHAR);
      end;

  end;

  Result := m;
end;

function TableHTML.E_table: Integer;
var
  beginning_of_E: Integer;
  end_1: Integer;
  h: Integer;
  i: Integer;
  k: Integer;
  m: Integer;
begin
  for i := 0 to H_FF do
  begin
    E[i] := NOT_CONVERTED;
  end;

{ 0 to 9 }
  beginning_of_E := H_30;

  end_1 := H_39 - 1;
  E[H_30] := 0;
  h := E[H_30];
  m := H_31;

  for k := beginning_of_E to end_1 do
  begin
    Inc(h);
    E[m] := h;
    Inc(m);
  end;

{ A to F }
  beginning_of_E := H_41;

  end_1 := H_46 - 1;
  E[H_41] := 10; { 'A' }
  h := E[H_41];
  m := H_42;

  for k := beginning_of_E to end_1 do
  begin
    Inc(h);
    E[m] := h;
    Inc(m);
  end;

  Result := h; { 'F' }
end;

function TableHTML.file_size(name: String): Integer;
var
  f: Integer;
  size: Integer;
begin
  f := FileOpen(name, fmOpenRead or fmShareDenyNone);
  size := FileSeek(f, 0, 2); { EOF }
  FileClose(f);
  Result := size;
end;

function TableHTML.hexadecimalCharacter(c: Char): Boolean;
var
  q: Integer;
  r: Boolean;
begin
  q := AnsiPos(c, HEXADECIMAL_CHARACTERS);
  if q > 0 then
    r := True
  else
    r := False;

  Result := r;
end;

function TableHTML.head_of_HTML(m: Integer): Integer;
var
  block_has_been_read: Integer;
  c: AnsiChar;
  dough_size_1: Integer;
  found: Boolean;
  htmlFile: File;
  i: Longint;
  k: Integer;
  n: Integer;
  r: Integer;
  s: String;
begin
  dough_size_1 := dough_size - 1;
  k := 0;

  for n := 0 to dough_size_1 do
  begin
    dough[n] := #0;
  end;

  try
    AssignFile(htmlFile, CUT_HERE_HTML);
    Reset(htmlFile, SIZE_OF_ANSICHAR);

    repeat
      a := CLEAR_ARRAY;
      BlockRead(htmlFile, a, A_SIZE, block_has_been_read);

      for n := 0 to A_SIZE_1 do
      begin
        dough[k] := a[n];
        Inc(k);
        if k > dough_size_1 then
          break;

      end;
    until k > dough_size_1;

    CloseFile(htmlFile);
  except
    s := 'Reset() error-104: ' + CUT_HERE_HTML;
    x := ErrorTexts.Create;
    x.setting(C_ERR, TEXT_FILE, s);
    x.Free;
  end;

  if (dough[0] = H_FF_C) and (dough[1] = H_FE_C) then
    beginning := BOM_SIZE
  else
    beginning := 0;

{ Finding a phrase: "Cut here." }
  for n := beginning to dough_size_1 do
  begin
    c := dough[n];
    i := Ord(c);

    if i = H_43 then
      begin
        for k := 0 to CUT_HERE_SIZE_1 do
        begin
          r := n + k;
          if r >= dough_size then
            begin
              s := 'Reset() error-105: r >= dough_size';
              x := ErrorTexts.Create;
              x.setting(C_ERR, TEXT_FILE, s);
              x.Free;
              Halt(1);
            end;

          i := Ord(dough[r]);
          if i = CUT_HERE[k] then
            begin
              found := True;
            end
          else
            begin
              found := False;
              break;
            end;

        end; { for k := 0 to CUT_HERE_SIZE_1 do }

        if found then
          begin
{ --> }
            combo[m] := Chr(H_2D);
            combo[ m + 1 ] := #0;
            Inc(m, SIZE_OF_WIDECHAR);

            combo[m] := Chr(H_2D);
            combo[ m + 1 ] := #0;
            Inc(m, SIZE_OF_WIDECHAR);

            combo[m] := Chr(H_3E);
            combo[ m + 1 ] := #0;
            Inc(m, SIZE_OF_WIDECHAR);

            trace := n + AWAY_FROM_CUT_HERE;
            break;
          end
        else
          begin
            combo[m] := c;
            Inc(m);
          end;

      end
    else
      begin
        combo[m] := c;
        Inc(m);
      end;

  end;

  Result := m;
end;

function TableHTML.hexadecimal_sequence_to_integer(s: PChar; s_length: Integer): Integer;
var
  c: Char;
  g: String;
  g_length: Integer;
  i: Longint;
  k: Integer;
  m: Integer;
  messages: String;
  n: Integer;
  s_length_1: Integer;
  term: Integer;
begin
  g := EMPTY;
  i := 0;
  m := 0;
  n := 0;
  s_length_1 := s_length - 1;

  for k := 0 to s_length_1 do
  begin
    c := s[k];
    if hexadecimalCharacter(c) then
      begin
        g := g + c;
      end
    else
      begin
        break;
      end;

  end;

  g_length := Length(g);
  try
    for k := g_length downto 1 do
    begin
      i := Ord(g[k]);
      term := E[i] * H[m];
      if term < 0 then
        raise Exception.Create('hexadecimal_sequence_to_integer() error');

      n := n + term;
      Inc(m);
    end;

  except
    messages := 'hexadecimal_sequence_to_integer() error-106: i = ' + IntToStr(i);
    x := ErrorTexts.Create;
    x.setting(C_ERR, TEXT_FILE, messages);
    x.Free;
    n := NOT_CONVERTED;
    Halt(1);
  end;

  Result := n;
end;

function TableHTML.newLine(m: Integer): Integer;
begin
{ new line }
  combo[m] := H_0D_C;
  combo[ m + 1 ] := #0;
  Inc(m, SIZE_OF_WIDECHAR);

  combo[m] := H_0A_C;
  combo[ m + 1 ] := #0;
  Inc(m, SIZE_OF_WIDECHAR);

  Result := m;
end;

function TableHTML.reading: Integer;
var
  basic_code: Integer;
  exit_code: Integer;
  f: String;
  flag: TReplaceFlags;
  k: Integer;
  kanji_code: Integer;
  m: Integer;
  n: Integer;
  r: Integer;
  s: String;
  s_length: Integer;
  testFile: TextFile;
begin
  count := 0;
  exit_code := 0;
  m := 0;
  combo[m] := H_FF_C;
  combo[ m + 1 ] := H_FE_C;
  Inc(m, KANJI_SIZE);

  dough_size := file_size(CUT_HERE_HTML);
  dough_size_1 := dough_size - 1;

  try
    SetLength(dough, dough_size);
  except
    s := 'SetLength() error-107: ' + IntToStr(dough_size);
    x := ErrorTexts.Create;
    x.setting(C_ERR, TEXT_FILE, s);
    x.Free;
    Halt(1);
  end;

  m := head_of_HTML(m);

  try
    AssignFile(testFile, file_name);
    Reset(testFile);

    TABLE_NUMBER[0] := '1';
    for n := 1 to MAXIMUM_TABLE_NUMBER do
    begin
      flag := [rfReplaceAll];
      TABLE_NUMBER[n] := IntToStr(n);
      TABLE_ROW[2] := StringReplace(TABLE_ROW[2], TABLE_NUMBER[ n - 1 ], TABLE_NUMBER[n], flag);

      for r := 1 to END_OF_HEADER do
      begin
        m := copying_string_to_part_of_array(TABLE_ROW[r], m);
        m := newLine(m);
      end;

      while not Eof(testFile) do
      begin
        ReadLn(testFile, s);
        s_length := Length(s);
        if s_length = 0 then
          break;

        kanji_code := hexadecimal_sequence_to_integer( PChar(s), Length(s) );
        m := copying_string_to_part_of_array(BEGINNING_OF_TABLE_ROW, m);

{ Four bytes of UTF-16 }
        basic_code := kanji_code - H_00010000;
        k := basic_code shr 10;
        higher_part_of_kanji := k + B_110110_S;

        k := higher_part_of_kanji and H_00FF;
        combo[m] := Chr(k); { little-endian architecture }

        k := higher_part_of_kanji shr 8;
        k := k and H_00FF;
        combo[ m + 1 ] := Chr(k);
        Inc(m, KANJI_SIZE);

        basic_code := kanji_code - H_00010000;
        k := basic_code and LOWER_PART_MASK;
        lower_part_of_kanji := k + B_110111_S;

        k := lower_part_of_kanji and H_00FF;
        combo[m] := Chr(k); { little-endian architecture }

        k := lower_part_of_kanji shr 8;
        k := k and H_00FF;
        combo[ m + 1 ] := Chr(k);
        Inc(m, KANJI_SIZE);
        m := copying_string_to_part_of_array(FIELD_SEPARATOR, m);

{ higher-part and lower-part of kanji }
        f := Format('%4x', [higher_part_of_kanji]);
        m := copying_string_to_part_of_array(f, m);
        m := copying_string_to_part_of_array(FIELD_SEPARATOR, m);

        f := Format('%4x', [lower_part_of_kanji]);
        m := copying_string_to_part_of_array(f, m);
        m := copying_string_to_part_of_array(FIELD_SEPARATOR, m);

{ Unicode }
        f := Format('%5x', [kanji_code]);
        m := copying_string_to_part_of_array(f, m);
        m := copying_string_to_part_of_array(FIELD_SEPARATOR, m);

{ Higher-part of kanji will be useful for arrays if software subtracts H_D840 from the kanji code. }
        higher_part_of_kanji := higher_part_of_kanji - H_D840;

{ Lower-part of kanji will be useful for arrays if software subtracts H_DC02 from the kanji code. }
        lower_part_of_kanji := lower_part_of_kanji - H_DC02;
        f := Format('%d', [higher_part_of_kanji]);
        m := copying_string_to_part_of_array(f, m);
        m := copying_string_to_part_of_array(FIELD_SEPARATOR, m);

        f := Format('%d', [lower_part_of_kanji]);
        m := copying_string_to_part_of_array(f, m);
        m := copying_string_to_part_of_array(FIELD_SEPARATOR, m);

{ Underline of 0xFF3F }
        combo[m] := Chr(H_3F); { little-endian architecture }
        combo[ m + 1 ] := H_FF_C;
        Inc(m, KANJI_SIZE);

        m := copying_string_to_part_of_array(END_OF_TABLE_ROW, m);
        m := newLine(m);
        Inc(count);
        if count >= GROUP_SIZE then
          begin
            count := 0;
            break;
          end;

      end; { while not Eof(testFile) do }

      for r := NEAR_END_OF_TABLE to TABLE_ROW_ARRAY_COUNT do
      begin
        m := copying_string_to_part_of_array(TABLE_ROW[r], m);
        m := newLine(m);
      end;

      if Eof(testFile) then
        break;

    end; { for n := 1 to MAXIMUM_TABLE_NUMBER do }

    m := tail_of_HTML(m);
    CloseFile(testFile);
    comboLength := m;
    bufferingWriting(comboLength);
  except
    s := 'Reset() error-108: ' + file_name;
    x := ErrorTexts.Create;
    x.setting(C_ERR, TEXT_FILE, s);
    x.Free;
    exit_code := FILE_ERROR;
  end;

  Result := exit_code;
end;

function TableHTML.setBufferSize: Integer;
var
  r: Integer;
  s: String;
begin
  r := combo_size;

  try
    SetLength(combo, combo_size);
  except
    s := 'SetLength() error-109: ' + IntToStr(combo_size);
    x := ErrorTexts.Create;
    x.setting(C_ERR, TEXT_FILE, s);
    x.Free;
    r := COMBO_ERROR;
  end;

  Result := r;
end;

function TableHTML.tail_of_HTML(m: Integer): Integer;
var
  n: Integer;
begin
  for n := trace to dough_size_1 do
  begin
    combo[m] := dough[n];
    Inc(m);
  end;

  Result := m;
end;

procedure TableHTML.setting(fn: String; nn: String);
var
  buffer_size: Integer;
  i: Integer;
  s: String;
  testFile: File;
begin
  file_name := fn;
  new_name := nn;

  try
    AssignFile(testFile, file_name);
    Reset(testFile, SIZE_OF_ANSICHAR);
    CloseFile(testFile);

    buffer_size := file_size(file_name);
    combo_size := EXPANSION_FACTOR * buffer_size;
  except
    s := 'Reset() error-110: ' + file_name;
    x := ErrorTexts.Create;
    x.setting(C_ERR, TEXT_FILE, s);
    x.Free;
  end;

  A_SIZE := SizeOf(a);
  A_SIZE_1 := A_SIZE - 1;
  B_110110_S := B_110110 shl 10;
  B_110111_S := B_110111 shl 10;

  H[0] := 1;
  H[1] := 16;
  H[2] := 256;
  H[3] := 4096;
  H[4] := 65536;
  H[5] := 1048576;
  H[6] := 16777216;
  H[7] := 268435456;

  TABLE_ROW[1] := LINE01;
  TABLE_ROW[2] := LINE02;
  TABLE_ROW[3] := LINE03;
  TABLE_ROW[4] := LINE04;
  TABLE_ROW[5] := LINE05;
  TABLE_ROW[6] := LINE06;
  TABLE_ROW[7] := LINE07;
  TABLE_ROW[8] := LINE08;
  TABLE_ROW[9] := LINE09;
  TABLE_ROW[10] := LINE10;
  TABLE_ROW[11] := LINE11;
  TABLE_ROW[12] := LINE12;
  TABLE_ROW[13] := LINE13;
  TABLE_ROW[14] := LINE14;
  TABLE_ROW[15] := LINE15;
  TABLE_ROW[16] := LINE16;
  TABLE_ROW[17] := LINE17;
  TABLE_ROW[18] := LINE18;
  TABLE_ROW[19] := LINE19;
  TABLE_ROW[20] := LINE20;
  TABLE_ROW[21] := LINE21;
  TABLE_ROW[22] := LINE22;
  TABLE_ROW[23] := LINE23;
  TABLE_ROW[24] := LINE24;
  TABLE_ROW[25] := LINE25;
  TABLE_ROW[26] := LINE26;
  TABLE_ROW[27] := LINE27;
  TABLE_ROW[28] := LINE28;
  TABLE_ROW[29] := LINE29;

  E_table;
  H_FF_C := Chr(H_FF);
  COMMA_C := Chr(COMMA_BYTE);
  H_0A_C := Chr(H_0A);
  H_0D_C := Chr(H_0D);
  H_FE_C := Chr(H_FE);

  LOWER_PART_MASK := 1 + 2 + 4 + 8 + 16 + 32 + 64 + 128 + 256 + 512;

  CUT_HERE[0] := 67;   { 'C' }
  CUT_HERE[2] := 117;  { 'u' }
  CUT_HERE[4] := 116;  { 't' }
  CUT_HERE[6] := 32;   { ' ' }
  CUT_HERE[8] := 104;  { 'h' }
  CUT_HERE[10] := 101; { 'e' }
  CUT_HERE[12] := 114; { 'r' }
  CUT_HERE[14] := 101; { 'e' }
  CUT_HERE[16] := 46;  { '.' }
  CUT_HERE[1] := 0;
  CUT_HERE[3] := 0;
  CUT_HERE[5] := 0;
  CUT_HERE[7] := 0;
  CUT_HERE[9] := 0;
  CUT_HERE[11] := 0;
  CUT_HERE[13] := 0;
  CUT_HERE[15] := 0;
  CUT_HERE[17] := 0;

  for i := 0 to A_SIZE_1 do
  begin
    CLEAR_ARRAY[i] := #0;
  end;

  setBufferSize;

  t := FinalEffects.Create;
  t.setting;
  u := ConvertWiden.Create;
  u.setting(t);
end;

end.
