unit ErrorText;

{$I+}

interface

uses
  SysUtils, TimeName;

type
  ErrorTexts = class
  private
    base: String;
    extension: String;
    fileName: String;
    messages: String;
  public
    function errorFileName: String;
    procedure setting(b: String; e: String; m: String);
  end;

const
  SERIAL_NUMBER = True;

implementation

function ErrorTexts.errorFileName: String;
begin
  Result := fileName;
end;

procedure ErrorTexts.setting(b: String; e: String; m: String);
var
  errorFile: TextFile;
  t: TimeNames;
begin
  base := b;
  extension := e;
  messages := m;

  t := TimeNames.Create;
  t.setting(base, extension);
  fileName := t.temporaryName(SERIAL_NUMBER);
  AssignFile(errorFile, fileName);
  Rewrite(errorFile);
  Write(errorFile, messages);
  CloseFile(errorFile);
  t.Destroy;
end;

end.
