unit Guide;

{$I+}

interface

uses
  SysUtils;

type
  Guiding = class
  public
    procedure versionGuide(v: String; comments: Boolean);
  end;

const
  VERSION_TEXT = 'version.txt';

implementation

procedure Guiding.versionGuide(v: String; comments: Boolean);
var
  s: String;
  versionFile: TextFile;
begin
  AssignFile(versionFile, VERSION_TEXT);
  Rewrite(versionFile);
  WriteLn(versionFile, 'Unarfij Version ' + v );
  WriteLn(versionFile, '');
  if comments then
    begin
      WriteLn(versionFile, 'unarfij -d2 -p wide         # H and I are omitted from ASCII characters. ');
      WriteLn(versionFile, 'unarfij -d2 wide            # Remove combining characters. ');
      WriteLn(versionFile, 'unarfij -e2 -H\x26 wide     # Add a dot and & to Field-2 unless a dot appears. ');
      WriteLn(versionFile, 'unarfij -e2 -h0 wide        # Add a dot and 0 to Field-2 unless a dot appears. ');
      WriteLn(versionFile, 'unarfij -e2 wide            # Extract a decimal from Field-2. ');
      WriteLn(versionFile, 'unarfij -G                  # Guide ');
      WriteLn(versionFile, 'unarfij -j2 --out wide      # standard output ');
      WriteLn(versionFile, 'unarfij -j2 -D wide         # Do not search a table. ');
      WriteLn(versionFile, 'unarfij -j2 -F narrow wide  # Produce a narrow file that has Field-2. ');
      WriteLn(versionFile, 'unarfij -j2 -K wide         # Acquire a table name from set_unarfij.txt ');
      WriteLn(versionFile, 'unarfij -j2 -LF wide        # 0Dh is removed from every line. ');
      WriteLn(versionFile, 'unarfij -j2 -LF wide narrow # 0Dh is removed from every line. ');
      WriteLn(versionFile, 'unarfij -j2 -M  wide        # -M shows which table narfi uses. ');
      WriteLn(versionFile, 'unarfij -j2 -s, wide        # CSV ');
      WriteLn(versionFile, 'unarfij -j2 -S\l -x- csv    # Do not check if the file name includes .csv ');
      WriteLn(versionFile, 'unarfij -j2 -S\l wide       # Wiki table ');
      WriteLn(versionFile, 'unarfij -j2 -t wide narrow  # The wide file has the same time as a narrow file.');
      WriteLn(versionFile, 'unarfij -j2 -w~ wide        # ~ is used as quote. ');
      WriteLn(versionFile, 'unarfij -j2 -W\x26 wide     # & is used as quote. ');
      WriteLn(versionFile, 'unarfij -j2 -Z wide         # The number of fields may exceed 255. ');
      WriteLn(versionFile, 'unarfij -j2 wide            # unarfij.txt has Field-2. ');
      WriteLn(versionFile, 'unarfij -j2 wide narrow     # Produce a narrow file that has Field-2. ');
      WriteLn(versionFile, 'unarfij -k2 -a_ wide        # In Field-2, Unarfij replaces katakana with ascii.');
      WriteLn(versionFile, 'unarfij -k2 -A\x5F wide     # In Field-2, Unarfij replaces katakana with ascii.');
      WriteLn(versionFile, 'unarfij -n2 wide            # Extract an integer from Field-2. ');
      WriteLn(versionFile, 'unarfij -o2 wide            # Remove control characters from Field-2. ');
      WriteLn(versionFile, 'unarfij -V                  # Version ');
    end
  else
    begin
      WriteLn(versionFile, 'unarfij --help               ');
    end;

  CloseFile(versionFile);

  AssignFile(versionFile, VERSION_TEXT);
  Reset(versionFile);
  while not Eof(versionFile) do
  begin
    ReadLn(versionFile, s);
    WriteLn(s);
  end;

  CloseFile(versionFile);
end;

end.
