unit PathEXE;

interface

uses
  Windows, SysUtils, FieldsArray, DivideSJIS, ErrorText;

type
  CommandPath = class
  private
   { buffer: array[0..4095] of Char; } { Delphi 4 }
    combo: array[0..4095] of AnsiChar;
    comboLength: Integer;
    EMPTY_ANSI: AnsiString;
    extra: AnsiString;
    full_path: String;
    manyErrorTexts: Boolean;
    x: ErrorTexts;
    function exeDirectories: Integer;
    function openClose(path_name: String): Boolean;
    function trimming(s: PChar; s_length: Integer): Integer;
  public
    function pathName(g: String): String;
    procedure setting(m: Boolean);
  end;

const
  C_ERR = 'err';
  EMPTY = '';
  H_0A = 10; { LF }
  H_0D = 13; { CR }
  H_3E = 62; { '>' }
  H_5C = 92; { '\' }
  H_7E = 126; { '~' }
  MANY = 256;
  PATH_TEXT = 'path.txt'; { Enter 'PATH > path.txt' }
  SEMICOLON_BYTE = 59; { 3B, ';' }
  SIZE_OF_CHAR = 1;
  TEXT_FILE = '.txt';

implementation

function CommandPath.exeDirectories: Integer;
var
  a: String;
  flag: TReplaceFlags;
  s: String;
begin
 { GetEnvironmentVariable('Path', @buffer, SizeOf(buffer) ); } { Delphi 4 }
 { a := buffer; }
  a := GetEnvironmentVariable('Path');  { FPC }
  flag := [rfReplaceAll];
  s := StringReplace(a, '\;', ';', flag);
  Result := trimming( PChar(s), Length(s) );
end;

function CommandPath.trimming(s: PChar; s_length: Integer): Integer;
var
  c: Char;
  i: Longint;
  k: Integer;
  m: Integer;
  s_length_1: Integer;
begin
  m := 0;
  s_length_1 := s_length - 1;

  for k := 0 to s_length_1 do
  begin
    c := s[k];
    i := Ord(c);

    if i = 0 then
      begin
        break;
      end
    else
      begin
        combo[m] := Chr(i);
        Inc(m);
      end;

  end;

  comboLength := m;
  Result := comboLength;
end;

function CommandPath.openClose(path_name: String): Boolean;
var
  b: Boolean;
  s: String;
  testFile: File;
begin
  b := False;

  try
    Assign(testFile, path_name);
    Reset(testFile);
    CloseFile(testFile);
    b := True;
  except
    if manyErrorTexts then
      begin
        s := 'Reset() error-208: ' + path_name;
        x := ErrorTexts.Create;
        x.setting(C_ERR, TEXT_FILE, s);
        x.Free;
      end;

  end;

  Result := b;
end;

function CommandPath.pathName(g: String): String;
var
  d: DividingSJIS;
  f: FieldsList;
  many_fields: Integer;
  field_count: Integer;
  i: Integer;
  r: String;
begin
  extra := g;

  many_fields:= MANY;
  r := EMPTY;

  f := FieldsList.Create;
  d := DividingSJIS.Create;
  d.presetting(SEMICOLON_BYTE);
  d.setting(f, many_fields);

  field_count := d.complementing_fields_list(combo, comboLength, extra, H_5C);
  full_path := EMPTY;

  for i := 0 to field_count do
  begin
    full_path := f.item(i);
    if openClose(full_path) then
      begin
        r := full_path;
        break;
      end;

  end;

  f.Free; d.Free;
  Result := r;
end;

procedure CommandPath.setting(m: Boolean);
begin
  manyErrorTexts := m;

  EMPTY_ANSI := '';

  exeDirectories;
end;

end.
