unit DeriveBinary;

{$I+}

interface

uses
  SysUtils, ErrorText;

type
  DeriveTable = class
  private
    r: array[1..4] of AnsiChar;
    w: array[1..5] of AnsiChar;
  public
    procedure setting;
  end;

const
  C_ERR = 'err';
  H_80 = 128;
  MS932_UTF16 = 'MS932~UTF16.bin';
  NEW_RECORD_SIZE = 5;
  RECORD_SIZE = 4;
  TEXT_FILE = '.txt';
  UTF16_MS932 = 'UTF16~MS932.bin';

implementation

procedure DeriveTable.setting;
var
  ASCII_C: AnsiChar;
  b: Longint;
  binaryFile: File;
  block_has_been_read: Integer;
  block_has_been_written: Integer;
  KANJI_C: AnsiChar;
  KATAKANA_C: AnsiChar;
  newFile: File;
  NON_KANJI_C: AnsiChar;
  s: String;
  x: ErrorTexts;
begin
  ASCII_C := #0;
  KANJI_C := #1;
  KATAKANA_C := #2;
  NON_KANJI_C := #0;

  AssignFile(newFile, UTF16_MS932);
  Rewrite(newFile, NEW_RECORD_SIZE);

  try
    AssignFile(binaryFile, MS932_UTF16);
    Reset(binaryFile, RECORD_SIZE);

    repeat
      BlockRead(binaryFile, r, 1, block_has_been_read);

      w[1] := r[3];
      w[2] := r[4];

      if r[2] = NON_KANJI_C then
        begin
          b := Ord(r[1]);
          if b < H_80 then
            begin
              w[3] := ASCII_C;
              w[4] := r[1];
              w[5] := NON_KANJI_C;
            end
          else
            begin
              w[3] := KATAKANA_C;
              w[4] := r[1];
              w[5] := NON_KANJI_C;
            end;

        end
      else
        begin
          w[3] := KANJI_C;
          w[4] := r[1];
          w[5] := r[2];
        end;

      BlockWrite(newFile, w, block_has_been_read, block_has_been_written);
    until block_has_been_read = 0;

    CloseFile(binaryFile);
  except
    s := 'Reset() error-139: ' + MS932_UTF16;
    x := ErrorTexts.Create;
    x.setting(C_ERR, TEXT_FILE, s);
    x.Free;
  end;

  CloseFile(newFile);
end;

end.
