unit FinalEffect;

interface

uses
  SysUtils;

type
  FinalEffects = class
  private
    ascii_file: Boolean;
    carriage_return: Boolean;
    field_to_be_selected: Integer;
    file_name: String;
    identical_time: Boolean;
    joint_byte: Byte;
    new_name: String;
    no_removing: Boolean;
    no_searching: Boolean;
    path_name: String;
    point: Integer;
    remove_0Dh: Boolean;
    remove_controllers: Boolean;
    selected_directory_has_priority: Boolean;
    surrogate_pair_to_underline: Boolean;
    temporary_binary: Boolean;
    which_table: Boolean;
  public
    function asciiText: Boolean;
    function atPoint: Integer;
    function carriageReturn: Boolean;
    function fieldSelected: Integer;
    function fileName: String;
    function jointByte: Byte;
    function identicalTime: Boolean;
    function newName: String;
    function noRemoving: Boolean;
    function noSearching: Boolean;
    function pathName: String;
    function priority: Boolean;
    function produceTemporaryBinary: Boolean;
    function remove0Dh: Boolean;
    function removeControllers: Boolean;
    function surrogatePairToUnderline: Boolean;
    function whichTable: Boolean;
    procedure setting(fn: String; nn: String; ft: Integer; sp: Boolean); overload;
    procedure setting(fn: String; nn: String; pn: String; 
      aa: Integer; ft: Integer; 
      jb: Byte; 
      af: Boolean; cr: Boolean; it: Boolean; nr: Boolean; ns: Boolean; r0: Boolean; rc: Boolean; sd: Boolean; sp: Boolean; tb: Boolean; wt: Boolean); overload;

  end;

implementation

function FinalEffects.asciiText: Boolean;
begin
  Result := ascii_file;
end;

function FinalEffects.atPoint: Integer;
begin
  Result := point;
end;

function FinalEffects.carriageReturn: Boolean;
begin
  Result := carriage_return;
end;

function FinalEffects.fieldSelected: Integer;
begin
  Result := field_to_be_selected;
end;

function FinalEffects.fileName: String;
begin
  Result := file_name;
end;

function FinalEffects.jointByte: Byte;
begin
  Result := joint_byte;
end;

function FinalEffects.identicalTime: Boolean;
begin
  Result := identical_time;
end;

function FinalEffects.newName: String;
begin
  Result := new_name;
end;

function FinalEffects.noRemoving: Boolean;
begin
  Result := no_removing;
end;

function FinalEffects.noSearching: Boolean;
begin
  Result := no_searching;
end;

function FinalEffects.pathName: String;
begin
  Result := path_name;
end;

function FinalEffects.priority: Boolean;
begin
  Result := selected_directory_has_priority;
end;

function FinalEffects.produceTemporaryBinary: Boolean;
begin
  Result := temporary_binary;
end;

function FinalEffects.remove0Dh: Boolean;
begin
  Result := remove_0Dh;
end;

function FinalEffects.removeControllers: Boolean;
begin
  Result := remove_controllers;
end;

function FinalEffects.surrogatePairToUnderline: Boolean;
begin
  Result := surrogate_pair_to_underline;
end;

function FinalEffects.whichTable: Boolean;
begin
  Result := which_table;
end;

procedure FinalEffects.setting(fn: String; nn: String; ft: Integer; sp: Boolean);
begin
{ String }
  file_name := fn;
  new_name := nn;
  path_name := '';

{ Integer }
  field_to_be_selected := ft;
  point := 1;

{ Byte }
  joint_byte := 95; { 5Fh, '_' }

{ Boolean }
  ascii_file := False;
  carriage_return := True;
  identical_time := False;
  no_removing := False;
  no_searching := False;
  remove_0Dh := False;
  remove_controllers := False;
  selected_directory_has_priority := False;
  surrogate_pair_to_underline := sp;
  temporary_binary := False;
  which_table := False;
end;

procedure FinalEffects.setting(fn: String; nn: String; pn: String; 
  aa: Integer; ft: Integer; 
  jb: Byte; 
  af: Boolean; cr: Boolean; it: Boolean; nr: Boolean; ns: Boolean; r0: Boolean; rc: Boolean; sd: Boolean; sp: Boolean; tb: Boolean; wt: Boolean);

begin
{ String }
  file_name := fn;
  new_name := nn;
  path_name := pn;

{ Integer }
  field_to_be_selected := ft;
  point := aa; { at and around the point }

{ Byte }
  joint_byte := jb;

{ Boolean }
  ascii_file := af;
  carriage_return := cr;
  identical_time := it;
  no_removing := nr;
  no_searching := ns;
  remove_0Dh := r0;
  remove_controllers := rc;
  selected_directory_has_priority := sd;
  surrogate_pair_to_underline := sp;
  temporary_binary := tb;
  which_table := wt;
end;

end.
