unit Guide;

interface

uses
  SysUtils;

type
  Guiding = class
  public
    procedure versionGuide(v: String; comments: Boolean);
  end;

const
  VERSION_TEXT = 'version.txt';

implementation

procedure Guiding.versionGuide(v: String; comments: Boolean);
begin
  WriteLn( 'Utf16sjis FPC Version ' + v );
  WriteLn('');
  if comments then
    begin
      WriteLn('utf16sjis                 # Produce UTF16~MS932.bin. ');
      WriteLn('utf16sjis UTF16           # Produce utf16sjis.txt ');
      WriteLn('utf16sjis UTF16 SJIS      # Produce a new file. ');
      WriteLn('utf16sjis -o SJIS UTF16   # Produce a new file. ');
      WriteLn('utf16sjis --out UTF16     # standard output ');
      WriteLn('utf16sjis -0 UTF16        # Every line includes 0Dh. ');
      WriteLn('utf16sjis -t UTF16 SJIS   # UTF16 has the same time as SJIS. ');
      WriteLn('utf16sjis -a UTF16        # Acquire a table name from set_utf16sjis.txt ');
      WriteLn('utf16sjis -b UTF16        # Produce binary.tmp ');
      WriteLn('utf16sjis -b UTF16 UTF16  # Produce and rename binary.tmp ');
      WriteLn('utf16sjis -b -y UTF16     # Do not remove binary.tmp ');
      WriteLn('utf16sjis -d UTF16        # Do not search a table. ');
      WriteLn('utf16sjis -G              # Guide ');
      WriteLn('utf16sjis -k -j_          # Replace kanji with _. Remove control characters. ');
      WriteLn('utf16sjis -k -J\x7C       # Replace kanji with |. Remove control characters. ');
      WriteLn('utf16sjis -LF UTF16       # 0Dh is removed from every line. ');
      WriteLn('utf16sjis -r2 UTF16       # Select Field-2 from UTF16 to produce SJIS. ');
      WriteLn('utf16sjis -s UTF16        # Remove control characters. ');
      WriteLn('utf16sjis -u UTF16        # Replace surrogate-pair kanji with Q. ');
      WriteLn('utf16sjis -w UTF16        # -w shows which table utf16sjis uses.');
      WriteLn('utf16sjis -V              # Version ');
    end
  else
    begin
      WriteLn('utf16sjis                 ');
      WriteLn('utf16sjis UTF16           ');
      WriteLn('utf16sjis UTF16 SJIS      ');
      WriteLn('utf16sjis -o SJIS UTF16   ');
      WriteLn('utf16sjis --out UTF16     ');
      WriteLn('utf16sjis -0 UTF16        ');
      WriteLn('utf16sjis -t UTF16 SJIS   ');
      WriteLn('utf16sjis -a UTF16        ');
      WriteLn('utf16sjis -b UTF16        ');
      WriteLn('utf16sjis -b UTF16 UTF16  ');
      WriteLn('utf16sjis -b -y UTF16     ');
      WriteLn('utf16sjis -d UTF16        ');
      WriteLn('utf16sjis -G              ');
      WriteLn('utf16sjis -k -j_          ');
      WriteLn('utf16sjis -k -J\x7C       ');
      WriteLn('utf16sjis -LF UTF16       ');
      WriteLn('utf16sjis -s UTF16        ');
      WriteLn('utf16sjis -u UTF16        ');
      WriteLn('utf16sjis -w UTF16        ');
      WriteLn('utf16sjis -V              ');
    end;

end;

end.
