unit PutCSV;

{$I+}

interface

uses
  SysUtils, ErrorText;

type AnsiCharArray = array[0..4095] of AnsiChar;

type
  PutSurroCSV = class
  private
    CLEAR_ARRAY: AnsiCharArray;
    combo: AnsiCharArray;
    H_FE_C: AnsiChar;
    H_FF_C: AnsiChar;
    new_name: String;
    v: AnsiCharArray;
    V_SIZE: Integer;
    V_SIZE_1: Integer;
    x: ErrorTexts;
  public
    function bufferingWriting(comboLength: Integer): Integer;
    procedure setting(nn: String);
  end;

const
  C_ERR = 'err';
  FILE_ERROR = -2;
  H_FE = 254;
  H_FF = 255;
  SIZE_OF_ANSICHAR = 1;
  TEXT_FILE = '.txt';

implementation

function PutSurroCSV.bufferingWriting(comboLength: Integer): Integer;
var
  block_has_been_written: Integer;
  exit_code: Integer;
  k: Integer;
  n: Integer;
  newFile: File;
  s: String;
begin
  exit_code := 0;
  n := 0;

{ Writing }
  try
    AssignFile(newFile, new_name);
    Rewrite(newFile, SIZE_OF_ANSICHAR);

    repeat
      v := CLEAR_ARRAY;

      for k := 0 to V_SIZE_1 do
      begin
        v[k] := combo[n];
        Inc(n);
        if n >= comboLength then
          begin
            V_SIZE := k + 1;
            V_SIZE_1 := V_SIZE - 1;
            break;
          end;

      end;

      BlockWrite(newFile, v, V_SIZE, block_has_been_written);
    until n >= comboLength;

    CloseFile(newFile);
    V_SIZE := SizeOf(v);
    V_SIZE_1 := V_SIZE - 1;
  except
    s := 'Rewrite() error-152: ' + new_name;
    x := ErrorTexts.Create;
    x.setting(C_ERR, TEXT_FILE, s);
    x.Free;
    exit_code := FILE_ERROR;
  end;

  Result := exit_code;
end;

procedure PutSurroCSV.setting(nn: String);
var
  i: Integer;
  m: Integer;
begin
  new_name := nn;

  V_SIZE := SizeOf(v);
  V_SIZE_1 := V_SIZE - 1;

  for i := 0 to V_SIZE_1 do
  begin
    CLEAR_ARRAY[i] := #0;
  end;

{ Characters of AnsiChar type }
  H_FF_C := Chr(H_FF);
  H_FE_C := Chr(H_FE);

  m := 0;
  combo[m] := H_FF_C; Inc(m);
  combo[m] := H_FE_C; Inc(m);
  combo[m] := Chr(95); Inc(m);
  combo[m] := Chr(216); Inc(m);
  combo[m] := Chr(160); Inc(m);
  combo[m] := Chr(221); Inc(m);
  combo[m] := Chr(44); Inc(m);
  combo[m] := Chr(0); Inc(m);
  combo[m] := Chr(68); Inc(m);
  combo[m] := Chr(0); Inc(m);
  combo[m] := Chr(56); Inc(m);
  combo[m] := Chr(0); Inc(m);
  combo[m] := Chr(53); Inc(m);
  combo[m] := Chr(0); Inc(m);
  combo[m] := Chr(70); Inc(m);
  combo[m] := Chr(0); Inc(m);
  combo[m] := Chr(44); Inc(m);
  combo[m] := Chr(0); Inc(m);
  combo[m] := Chr(68); Inc(m);
  combo[m] := Chr(0); Inc(m);
  combo[m] := Chr(68); Inc(m);
  combo[m] := Chr(0); Inc(m);
  combo[m] := Chr(65); Inc(m);
  combo[m] := Chr(0); Inc(m);
  combo[m] := Chr(48); Inc(m);
  combo[m] := Chr(0); Inc(m);
  combo[m] := Chr(44); Inc(m);
  combo[m] := Chr(0); Inc(m);
  combo[m] := Chr(50); Inc(m);
  combo[m] := Chr(0); Inc(m);
  combo[m] := Chr(55); Inc(m);
  combo[m] := Chr(0); Inc(m);
  combo[m] := Chr(68); Inc(m);
  combo[m] := Chr(0); Inc(m);
  combo[m] := Chr(65); Inc(m);
  combo[m] := Chr(0); Inc(m);
  combo[m] := Chr(48); Inc(m);
  combo[m] := Chr(0); Inc(m);
  combo[m] := Chr(44); Inc(m);
  combo[m] := Chr(0); Inc(m);
  combo[m] := Chr(51); Inc(m);
  combo[m] := Chr(0); Inc(m);
  combo[m] := Chr(49); Inc(m);
  combo[m] := Chr(0); Inc(m);
  combo[m] := Chr(44); Inc(m);
  combo[m] := Chr(0); Inc(m);
  combo[m] := Chr(52); Inc(m);
  combo[m] := Chr(0); Inc(m);
  combo[m] := Chr(49); Inc(m);
  combo[m] := Chr(0); Inc(m);
  combo[m] := Chr(52); Inc(m);
  combo[m] := Chr(0); Inc(m);
  combo[m] := Chr(44); Inc(m);
  combo[m] := Chr(0); Inc(m);
  combo[m] := Chr(227); Inc(m);
  combo[m] := Chr(140); Inc(m);
  combo[m] := Chr(13); Inc(m);
  combo[m] := Chr(0); Inc(m);
  combo[m] := Chr(10); Inc(m);
  combo[m] := Chr(0); Inc(m);

  bufferingWriting(m);
end;

end.
