unit Ucombo;

interface

uses
  SysUtils;

type
  UniversalComboAppend = class
  private
    combo: String;
    separator: Char;
    function singleByte(s: String): Byte;
  public
    function built: String;
    function comboSize: Integer;
    procedure append(b: Byte); overload;
    procedure append(c: Char); overload;
    procedure append(d: Double); overload;
    procedure append(i: Integer); overload;
    procedure append(s: String); overload;
    procedure separatorFollows(b: Byte); overload;
    procedure separatorFollows(c: Char); overload;
    procedure separatorFollows(d: Double); overload;
    procedure separatorFollows(i: Integer); overload;
    procedure separatorFollows(s: String); overload;
    procedure setting; overload;
    procedure setting(c: Char); overload;
    procedure setting(s: String); overload;
  end;

const
  EMPTY = '';
  H_000000FF = 255;
  TAB = 9; { 09h }

implementation

function UniversalComboAppend.built: String;
begin
  Result := combo;
end;

function UniversalComboAppend.comboSize: Integer;
begin
  Result := Length(combo);
end;

function UniversalComboAppend.singleByte(s: String): Byte;
var
  c: array[0..255] of Char;
  i: Longint;
begin
{ Providing the ASCII code of the first character }
  StrPCopy(c, s);
  i := Ord(c[0]);
  i := H_000000FF and i;
  Result := Byte(i);
end;

procedure UniversalComboAppend.append(b: Byte);
begin
  combo := combo + Chr(b);
end;

procedure UniversalComboAppend.append(c: Char);
begin
  combo := combo + c;
end;

procedure UniversalComboAppend.append(d: Double);
begin
  combo := combo + FloatToStr(d);
end;

procedure UniversalComboAppend.append(i: Integer);
begin
  combo := combo + IntToStr(i);
end;

procedure UniversalComboAppend.append(s: String);
begin
  combo := combo + s;
end;

procedure UniversalComboAppend.separatorFollows(b: Byte);
begin
  combo := combo + Chr(b);
  combo := combo + separator;
end;

procedure UniversalComboAppend.separatorFollows(c: Char);
begin
  combo := combo + c;
  combo := combo + separator;
end;

procedure UniversalComboAppend.separatorFollows(d: Double);
begin
  combo := combo + FloatToStr(d);
  combo := combo + separator;
end;

procedure UniversalComboAppend.separatorFollows(i: Integer);
begin
  combo := combo + IntToStr(i);
  combo := combo + separator;
end;

procedure UniversalComboAppend.separatorFollows(s: String);
begin
  combo := combo + s;
  combo := combo + separator;
end;

procedure UniversalComboAppend.setting;
begin
  combo := EMPTY;
  separator := Chr(TAB);
end;

procedure UniversalComboAppend.setting(c: Char);
begin
  separator := c;
  combo := EMPTY;
end;

procedure UniversalComboAppend.setting(s: String);
var
  b: Byte;
begin
  b := singleByte(s);
  separator := Chr(b);
  combo := EMPTY;
end;

end.
